(* Q1 *)
(* Bien faire attention à ne pas mélanger
les float et les int *)
let n_roots (a, b, c) = 
	let delta = b*.b -. 4.*.a*.c in
	if delta < 0. then 0
	else if delta = 0. then 1
	else 2
;;

(* X^2 + 2X + 1 a une racine réelle *)
let n1 = n_roots (1., 2., 1.) in
assert (n1 = 1);;
(* X^2 - 3X + 3 n'a  pas de racine réelle *)
let n2 = n_roots (1., -3., 3.) in
assert (n2 = 0);;
(* X^2 + X - 12 a deux racines réelles *)
let n3 = n_roots (1., 1., -12.) in 
assert (n3 = 2);;



(* Q2 *)
let nom_chiffre n =
	if n = 2 then "deux"
	else if n = 3 then "trois"
	else if n = 4 then "quatre"
	else if n = 5 then "cinq"
	else ""

(* avec pattern matching: *)
let nom_chiffre n =
	match n with
	| 2 -> "deux"
	| 3 -> "trois"
	| 4 -> "quatre"
	| 5 -> "cinq"
	| _ -> ""



(* Q3 *)
(* Q4 *)
let f x y = 
	match (x-1, y) with
	| (0, 0) -> 0
	| (0, _) -> y + 1
	| (z, 0) -> z + 100
	| _ -> x * y
;;

print_int (f 1 0); print_newline () ;; (* 0 *)
print_int (f 1 3); print_newline () ;; (* 3 = 3 + 1 *)
print_int (f 6 0); print_newline () ;; (* 105 = 5 + 100 *)
print_int (f 3 5); print_newline () ;; (* 15 = 3*5 *)

(* Q5 *)
let fonction_q5 x y =
	match (x+y, x-y) with
	| (0, _) -> 0 (* les deux premières lignes *)
	| (_, 0) -> 0 (* correspondent au 1er cas  *)

	| (z,  1) -> z*z + 1 (* cas numéro *)
	| (z, -1) -> z*z + 1 (* deux       *)
	
	| (1,  z) -> z*z - 1 (* cas numéro *)
	| (-1, z) -> z*z - 1 (* trois      *)

	| _ -> x * y (* Dernier cas *)

let q5a = fonction_q5 7 7    (* premier cas, renvoie 0 *)
let q5b = fonction_q5 4 5    (* 2eme cas, renvoie  82 *)
let q5c = fonction_q5 3 (-2) (* 3eme cas, renvoie  24 *)
let q5d = fonction_q5 7 9;;    (* dernier cas, renvoie 63 *)
assert (q5a = 0);;
assert (q5b = 82);;
assert (q5c = 24);;
assert (q5d = 63);;

(* Q6 *)
(* Ici il faut faire attention à l'ordre: si on
   met (0, _) avant (0, 0), il sera impossible
   d'activer le cas (0, 0) car (0, _) sera matché
   avant. *)
let gabu n = 
	match (n mod 3, n mod 5) with
	| (0, _)  -> "ga"
	| (_ , 0) -> "bu"
	| _       -> string_of_int n;;


let q6a = gabu 7   
let q6b = gabu 18  
let q6c = gabu 100
let q6d = gabu 60  ;; (* vaut bien "ga" grâce à l'ordre d'évaluation *)
assert(q6a = "7");;
assert(q6b = "ga");;
assert(q6c = "bu");;
assert(q6d = "ga");;
